<?php

// Backend scripts & styles
if (is_admin()) {
	DispletRetsIdxLoad::enqueue_css('jquery-ui-1.8.11.custom.css');
	wp_enqueue_script('displetreader-widget-config', plugins_url('displet-retsidx-beta/js/displetreader-widget-config.js'), array('jquery', 'jquery-ui-core', 'jquery-ui-dialog', 'jquery-ui-tabs', 'admin-widgets'));
}
// Frontend scripts & styles
else {
	wp_enqueue_script('jquery');
	DispletRetsIdxLoad::enqueue_css('displet-rets-idx-styles.css');
	DispletRetsIdxLoad::enqueue_js('displet-rets-idx-scripts.js', array('jquery', 'jquery-ui-core', 'jquery-ui-widget', 'jquery-ui-datepicker'));
}

class DispletRetsIdxLoad{
	public function echo_js_vars_from_options(){
		$model['options'] = DispletRetsIdxSettings::get_option();
		echo self::get_template('displet-javascript-variables.php', $model);
	}

	public function enqueue_css($stylesheet) {
		$theme_dir = get_stylesheet_directory();
		$theme_url = get_stylesheet_directory_uri();
		$slug = basename($stylesheet, '.css');
		if (file_exists($theme_dir . '/' . $stylesheet)) {
			wp_enqueue_style($slug, $theme_url . '/' . $stylesheet);
			return;
		}
		wp_enqueue_style($slug, plugins_url('displet-retsidx-beta/css/' . $stylesheet));
	}
	
	public function enqueue_js($script, $dependencies = array()) {
		$theme_dir = get_stylesheet_directory();
		$theme_url = get_stylesheet_directory_uri();
		$slug = basename($script, '.js');
		if (file_exists($theme_dir . '/' . $script)) {
			wp_enqueue_script($slug, $theme_url . '/' . $script, $dependencies);
			return;
		}
		wp_enqueue_script($slug, plugins_url('displet-retsidx-beta/js/' . $script), $dependencies);
	}

	public function get_template($name, &$model) {
		$theme_dir = get_stylesheet_directory();
		if ($name == 'custom') {
			$names = array('displet-dynamic.php', 'displet-listings.php', 'displet-tile.php');
			foreach ($names as $name) {
				if (file_exists($theme_dir . '/' . $name)) {
					return self::_render($theme_dir . '/' . $name, $model);
				}
			}
		}
		else{
			if (file_exists($theme_dir . '/' . $name)) {
				return self::_render($theme_dir . '/' . $name, $model);
			}
		}
		return self::_render(dirname( __FILE__ ) . '/templates/' . $name, $model);
	}

	public function get_admin_template($name, &$model) {
		return self::_render(dirname( __FILE__ ) . '/templates/admin/' . $name, $model);
	}
	
	public static function draw_admin_template($name, &$model, $model_alias = false) {
		echo self::get_admin_template($name, $model, $model_alias);
	}

	protected static function _render($path, &$model) {
		if (file_exists($path)) {
			ob_start();
			include $path;
			$output = ob_get_contents();
			ob_end_clean();
			return trim($output);
		}
	}
}

add_action('wp_head', array('DispletRetsIdxLoad', 'echo_js_vars_from_options'));

?>