<?php

class DispletRetsIdxListings{
	function render_shortcode($attributes){
		// Retrieve options from settings page
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
	
		// Create list of acceptable attributes (array keys) and a $model['key'] from each array key, using the shortcode attribute as the value when specified, else the setting default or other specification in array
		$model = shortcode_atts(array(
			// Has settings defaults
			'region' => stripslashes($displetretsidx_option['oodle_region']),
			'category' => stripslashes($displetretsidx_option['oodle_category']),
			'listings_per_page' => intval($displetretsidx_option['listings_per_page']),
			'orientation' => stripslashes($displetretsidx_option['listings_orientation']),
			'sort' => stripslashes($displetretsidx_option['listings_sort']),
			'price_navigation' => stripslashes($displetretsidx_option['include_price_navigation']),
			'stats' => stripslashes($displetretsidx_option['include_stats']),
			// Has only shortcode attributes
			'listings' => '',
			'caption' => '',
			'minlistprice' => '',
			'maxlistprice' => '',
			'minbedrooms' => '',
			'maxbedrooms' => '',
			'minbathrooms' => '',
			'maxbathrooms' => '',
			'minsquarefeet' => '',
			'maxsquarefeet' => '',
			'area' => '',
			'area_mls_defined' => '',
			'city' => '',
			'property_type' => '',
			'minstories' => '',
			'waterfront' => '',
			'pool_on_property' => '', 
			'subdivision' => '',
			'keyword' => '',
			'school' => '',
			'school_district' => '',
			'minacres' => '',
			'zip' => '',
			'is_foreclosure' => '',
			'yearbuilt' => '',
			'county' => '',
			'status' => '',
			'short_sale' => '',
			'last_modified' => '',
			'listing_agent_id' => '',
			'listing_office_id' => '',
			'min_lot_size' => '',
			'is_gated_community' => '',
			'min_sold_date' => '',
			'max_sold_date' => '',
			'master_on_main' => '',
			'basement' => '',
			'min_square_feet_available' => '',
			'max_square_feet_available' => '',
			'min_price_per_sq_feet' => '',
			'max_price_per_sq_feet' => '',
			'street_name' => '',
			'street_number' => ''
		), $attributes);
		$model['show_listings'] = $model['listings'];
		$model['listings'] = false;

		// Add settings to $model
		$model['options'] = $displetretsidx_option;
		$model['is_displet_api'] = (!empty($model['options']['displet_app_key'])) ? true : false;
		$model['return_fields'] = 'city,full_baths,half_baths,primary_big_image_urls,internet_remarks,latitude,list_price,longitude,mls_number,num_bedrooms,property_type,square_feet,state,status,street_name,street_number,street_post_dir,street_pre_direction,sysid,unit,zip';
		if (!empty($displetretsidx_option['include_subdivision'])) {
			$model['return_fields'] .= ',subdivision';
		}
		if (!empty($displetretsidx_option['include_listing_agent'])) {
			$model['return_fields'] .= ',listing_agent_name';
		}
		if (!empty($displetretsidx_option['include_listing_office'])) {
			$model['return_fields'] .= ',listing_office_name';
		}
	
		// Get query from $model
		$model['query_url'] = DispletRetsIdxQuery::get_query_url($model);
	
		// Get current page and create previous/next links, update start number if paginated
		$page_id = intval(get_query_var('paged'));
		$page_url = get_permalink();
		if ($page_id) {
			$next_page_id = $page_id + 1;
			$previous_page_id = $page_id - 1;
			if ($page_id < 2) {
				$previous_page = '/#previous';
			}
			else{
				$previous_page = '/page/' . $previous_page_id;
			}
			$next_page = '/page/' . $next_page_id;
			$model['previous_page_url'] = rtrim($page_url, '/') . $previous_page;
			$model['next_page_url'] = rtrim($page_url, '/') . $next_page;
			if ($page_id > 1) {
				if ($model['is_displet_api']) {
					$new_start = '&page=' . $page_id;
					$model['query_url'] = str_replace('&page=1', $new_start, $model['query_url']);
				}
				else{
					$start_id = ($page_id - 1) * $model['listings_per_page'] + 1;
					$new_start = '&start=' . $start_id;
					$model['query_url'] = str_replace('&start=1', $new_start, $model['query_url']);
				}
			}
		}
		else{
			$model['previous_page_url'] = rtrim($page_url, '/') . '/#previous';
			$model['next_page_url'] = rtrim($page_url, '/') . '/page/2';
		}
	
		// Get listings server-side to pass to templates for crawlable content
		$listings = DispletRetsIdxQuery::get_listings($model);
		$model = array_merge($model, $listings);
	
		// Grab appropriate templates
		$displet_templates = '';
		if (!empty($model['caption'])) {
			$displet_templates .= '<h2 class="displet-caption">' . $model['caption'] . '</h2>';	
		}
		if (intval($model['meta']->count) > 0) {
			$displet_templates .= DispletRetsIdxLoad::get_template('displet-listings-jquery.php', $model);
			if ($model['is_displet_api']) {
				if (!empty($model['price_navigation']) && strtolower($model['price_navigation']) != 'no' && strtolower($model['listings']) != 'no' && intval($model['meta']->count) > 9) {
					$displet_templates .= DispletRetsIdxLoad::get_template('displet-price-navigation.php', $model);
				}
				if (!empty($model['stats']) && strtolower($model['stats']) != 'no') {
					$displet_templates .= DispletRetsIdxLoad::get_template('displet-statistics.php', $model);
				}
			}
		}
		if (strtolower($model['show_listings']) != 'no') {
			$displet_templates .= DispletRetsIdxLoad::get_template('displet-dynamic.php', $model);
		}
	
		return $displet_templates;
	}

	public function render_shortcode_stats(){
		
	}
	
	function update_canonical(){
		// Determine if page contains DispletListing shortcode
		$shortcode = false;
		$regex = '/' . get_shortcode_regex() . '/s';
		global $posts;
		if (isset($posts[0])) {
			preg_match($regex, $posts[0]->post_content, $matches);
			if (is_array($matches) && isset($matches[2]) && $matches[2] == 'DispletListing') {
				$shortcode = true;
			}
		}
		// Remove default canonical and add ours
		if (get_query_var('paged') && $shortcode){
			remove_action('wp_head', 'rel_canonical');
			add_action('wp_head', array('DispletRetsIdxListings', 'add_canonical'), 1);
		}
	}

	function add_canonical(){
		// Add canonical that includes /page/id
		$link = rtrim(get_permalink(), '/');
		$paged = get_query_var('paged');
		if ($paged) {
			$link .= '/page/' . $paged;
		}
	    echo '<link rel="canonical" href="' . esc_url($link) . '" />';
	}

	function remove_yoasts_canonical($canonical) {
		// Determine if page contains DispletListing shortcode
		$shortcode = false;
		$regex = '/' . get_shortcode_regex() . '/s';
		global $posts;
		if (isset($posts[0])) {
			preg_match($regex, $posts[0]->post_content, $matches);
			if (is_array($matches) && isset($matches[2]) && $matches[2] == 'DispletListing') {
				$shortcode = true;
			}
		}
		if (get_query_var('paged') && $shortcode) {
	    	$canonical = false;
	    }
		return $canonical;
	}
}

add_shortcode('DispletListing', array('DispletRetsIdxListings', 'render_shortcode'));
add_shortcode('DispletStats', array('DispletRetsIdxListings', 'render_shortcode_stats'));
add_action('template_redirect', array('DispletRetsIdxListings', 'update_canonical'));
add_filter('wpseo_canonical', array('DispletRetsIdxListings', 'remove_yoasts_canonical'));

?>